/*#######################################################################################
AVR Small Webserver 

Copyright (C) 2004 Ulrich Radig

#######################################################################################*/

#include "main.h"
#include "ethernet.h"
#include "socket.h"
#include "interrupt4.h"

SIGNAL (Network_Card_INT)
{
	//printf ("interrupt\n");
	cli ();		//Globale Interrupts Ausschalten
	
	char ByteH = 0;
	char ByteL = 1;		

	//if the receive buffer has been overrun
	if ( (ReadRTL(ISR)&(1<<OVW)) != 0)	printf ("Overrun!\n");
		
	//gehe zu Routine GET wenn ein Packet empfangen wurde
	if ( (ReadRTL(ISR) & (1<<PRX)) != 0)
		{
		//NIC FIFO noch nicht leer
		//gehe zu Routine GET und lese ein weiteres Packet
		while (ByteL != ByteH) //(!= bedeutet ungleich)
			{
			get ();
			
			//auslesen des Empfangsbuffer BNRY = CURR 
			ByteL = ReadRTL(BNRY); //auslesen NIC Register bnry
			WriteRTL ( CR ,(1<<STA|1<<RD2|1<<PS0));

			ByteH = ReadRTL(CURR); //auslesen NIC Register curr
			WriteRTL ( CR ,(1<<STA|1<<RD2));
			} 
		}
		
	//Zurcksetzen der Interrupt Bits des NIC
	WriteRTL (ISR, (1<<PRX|1<<PTX|1<<RXE|1<<TXE|1<<OVW|1<<CNT|1<<RDC|1<<RST));
	
	//startet die Network Card
	Networkcard_Start();
	
	//Globale Interrupts wieder Einschalten
	sei ();
}

//############################################################################
//Hier werden Daten empfangen und es wird geprft was empfangen wurde 
int get (void)
//############################################################################
{
	unsigned int packetlen;						//Lnge des Ethernetpacketes
	unsigned char packet[MTU_SIZE+80];			//Array fr zu empfangene Daten und zu sendene Daten

	struct Ethernet_Header *ethernet;				//Pointer auf Ethernet_Header
	ethernet = (struct Ethernet_Header *)&packet[ETHER_OFFSET];
	
	struct IP_Header *ip;							//Pointer auf IP_Header
	ip = (struct IP_Header *)&packet[IP_OFFSET];
	
	struct TCP_Header *tcp;						//Pointer auf TCP_Header
	tcp = (struct TCP_Header *)&packet[TCP_OFFSET];

	Read_Ethernet_Frame (packet,&packetlen);		//Lese daten aus NIC FIFO ins Array packet() sowie packetheader()
	
	//2 Byte fr Nutzlastbereich (0806 fr ARP)
	if(Ethernet_ARP_Datagramm)						//wurde ein ARP packet empfangen?
		ARP_Reply(packet,&packetlen);				//Erzeugt ein ARP Reply Packet
	
	//2 Byte fr Nutzlastbereich (0800 fr IP) 
	else											//wurde ein ICMP, UDP oder TCP packet empfangen?
	{	
		if(Ethernet_IP_Datagramm && MyIP){			//Ist das IP Packet fr meine IP Addresse bestimmt
			
		if(IP_ICMP_Packet) ICMP_Reply(packet,packetlen);	//Ist protokoll Byte = 1 dann ist es ein ICMP Packet
			
		else if(IP_UDP_Packet)	printf("udp() \n");	//Ist protokoll Byte = 17 dann ist es ein UDP Packet
			
		else if(IP_TCP_Packet)						//Ist protokoll Byte = 6 dann ist es ein TCP Packet
			{
			//printf("tcp() \n");
			if (tcp->TCP_DestPort == SOCKET_HTTP)		httpd (packet,&packetlen);
			
			#if USE_FTPD
			if (tcp->TCP_DestPort == SOCKET_FTPD)		ftpd (packet,&packetlen);
			#endif //USE_FTPD
			
			#if USE_TELNET
			if (tcp->TCP_DestPort == SOCKET_TELNET)	telnet (packet,&packetlen);
			#endif //USE_TELNET
			}
		}
	}
	return (0);
}


