/*#######################################################################################
AVR Small Webserver 

Copyright (C) 2004 Ulrich Radig

Bei Fragen und Verbesserungen wendet euch per EMail an

mail@ulrichradig.de

oder im Forum meiner Web Page : www.ulrichradig.de


Dieses Programm ist freie Software. Sie knnen es unter den Bedingungen der 
GNU General Public License, wie von der Free Software Foundation verffentlicht, 
weitergeben und/oder modifizieren, entweder gem Version 2 der Lizenz oder 
(nach Ihrer Option) jeder spteren Version. 

Die Verffentlichung dieses Programms erfolgt in der Hoffnung, 
da es Ihnen von Nutzen sein wird, aber OHNE IRGENDEINE GARANTIE, 
sogar ohne die implizite Garantie der MARKTREIFE oder der VERWENDBARKEIT 
FR EINEN BESTIMMTEN ZWECK. Details finden Sie in der GNU General Public License. 

Sie sollten eine Kopie der GNU General Public License zusammen mit diesem 
Programm erhalten haben. 
Falls nicht, schreiben Sie an die Free Software Foundation, 
Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307, USA. 
#######################################################################################*/

#include "main.h"

extern void checkEEPROMip (void);

// Die MAC Addresse des Web Servers wird spter aus dem EEPROM der Netzwerkkarte geladen
unsigned char mymac[] = {1,2,3,4,5,6};

// Standard IP Addresse des Web Servers, kann mit der Adresse aus dem EEPROM
// berschrieben werden
unsigned char MYIP[] = {192,168,99,199};


//############################################################################
//Hauptprogramm
int main (void)
//############################################################################
{
	UART_Init();

#if USE_MMC	
	while (mmc_init() != 0) 		//ist der Rckgabewert ungleich NULL ist ein Fehler aufgetreten
		printf ("** Keine MMC/SD-Karte gefunden! **\n\n");// die MMC/SD-Karte wird dann neu Initialisiert
	printf ("MMC/SD-Karte gefunden!\n\n");
	Cluster_Data_Store();	//Speichern von Cluster Size und Cluster Offset (Anfang des Datenbereichs)
#endif

	Init_Realtek_Network_Card();	//Initialisierung der Netzwerkkarte

	if(ReadRTL(0) == 34)	printf ("Init: Okay 34"); 
		else 				printf ("Init: ERROR(%d)",ReadRTL(0));

	// Ausgabe der MAC Adresse auf der seriellen Schnittstelle
	printf ("\nMAC: %02X:%02X:%02X:%02X:%02X:%02X\n",mymac[0],mymac[1],mymac[2],mymac[3],mymac[4],mymac[5]);

	checkEEPROMip();	// IP-Adresse ersetzen, wenn im EEPROM eine gltige Adresse steht

	// Ausgabe der IP Adresse auf der seriellen Schnittstelle
	printf ("IP : %d.%d.%d.%d\n",MYIP[0],MYIP[1],MYIP[2],MYIP[3]);	
	VAi=MYIP[0];	VAj=MYIP[1];
	VAk=MYIP[2];	VAl=MYIP[3];	// Variablen zum Verstellen der IP-Adresse initialisieren

	//***********************************************************************************************
	// Einschub von jb 24.07.2005
	// Speicherdump des AVR-EEPROMs auf der seriellen Schnittstelle ausgeben
	printf("\n\nEEPROM Dump:\n");	// berschrift ausgeben
	dump (1024,*readEEPROM);		// EEPROM-Speicherdump mit 1024 Byte ausgeben
	// Ende des Einschubs
	//***********************************************************************************************

	sei ();	//Globale Interrupts Einschalten
	
	//Interrupt 4 bei Mega103/128 oder Interrupt 0 bei Mega32, soll bei ansteigender Flanke auslsen
	Networkcard_INT_Set();
	Networkcard_INT_Enable();	//Interrupt fr die Netzwerkkarte (4 oder 0) einschalten

#if USE_CLOCK
	Start_Clock();
#endif
	
	// Initialisierung des LED-Pins
	LED_LINES		&= (0<<LED_PIN);	// Datenleitung auf "0" setzen
	LED_LINES_DIR	|= (1<<LED_PIN);	// Richtungsregister: LED_PIN = Output
	
	// Phase correct PWM Mode fr OC2 einschalten, CLK/32 d.h. 980 Hz Signalfrequenz bei 16 MHz Takt
	TCCR2			= 0x63;				
	VA2				= 63;	// Startwert = 25% Helligkeit
	OCR2			= VA2;	// Startwert setzen
	
	VAR	= 3;				// refresh-Zeit fr Temperaturmessungen setzen
	
	OWImain();				// one-wire Schnittstelle bedienen
	
	while (1)
		{	}				//Hauptprogramm luft stndig in einer Schleife und macht nichts
return (1);
}
