/*#######################################################################################
AVR Small Webserver 

Copyright (C) 2004 Ulrich Radig

#######################################################################################*/

#ifndef _MAIN_H
 #define _MAIN_H

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <avr/io.h>
#include <avr/pgmspace.h>
#include <avr/interrupt.h>
#include <avr/signal.h>
#include <avr/eeprom.h>

#include "mmc.h"
#include "interrupt4.h"
#include "fat.h"
#include "rtl8019.h"
#include "tcp.h"
#include "arp.h"
#include "ip.h"
#include "icmp.h"
#include "clock.h"
#include "uart.h"
#include "ftpd.h"
#include "webpage.h"
#include "telnet.h"
#include "dump.h"

extern	 int checksum	(unsigned char * ,unsigned int,unsigned long);
extern	void httpd		(char* buffer,int *bufferlen);
extern	void OWImain	(void);

extern unsigned char mymac[];		// MAC-Adresse
extern unsigned char MYIP[];			// IP-Adresse
unsigned char	VA0;					// temp. Variable
unsigned char	VA2;					// LED-Status
unsigned char	VA3;					// Dallas-Ausgabeschalter
unsigned char	VA4;					// Busleitung4
unsigned char	VA5;					// Busleitung5
unsigned char	VA6;					// Busleitung6
unsigned char	VA7;					// Index fr Namensseite
unsigned char	VAi;					// neues Adrebyte
unsigned char	VAj;					// neues Adrebyte
unsigned char	VAk;					// neues Adrebyte
unsigned char	VAl;					// neues Adrebyte
unsigned char	VAR;					// refresh-Zeit
signed char Index;					// Index fr HTML-Wiederholungsschleifen
PGM_P Zeiger;							//


// Leuchtdiodenport festlegen
#define LED_LINES		PORTD	// Port mit der LED
#define LED_LINES_DIR	DDRD	// Richtungsregister (Eingang oder Ausgang)
#define LED_PIN			7		// Pin an dem die LED angeschlossen ist

// Festlegungen fr das one-wire-interface
#define MAX_DEVICES 	17       	// maximale Anzahl der Dallas-Bausteine + 1
unsigned char BUSES; 				// Busleitungen (evtl. mehrere Bits durch | verknpfen)
unsigned char	DALLAS[MAX_DEVICES][2];	// Platz fr MAX_DEVICES-1 Dallaschips

//Festlegungen zum EEPROM-Inhalt
#define IPoffset	8


//MTU Size setzen (min. 500 / max. 1400)
#define MTU_SIZE  700

//Der Quarz auf dem Experimentierboard hat eine Frequenz von 14.318MHz
//#define SYSCLK	14318180	//Quarz Frequenz in Hz

#define SYSCLK	16000000	//Quarz Frequenz in Hz


#if defined (__AVR_ATmega32__)	
	#define Networkcard_INT_Enable()	enable_external_int (1<<INT0);
	#define Networkcard_INT_Set()	MCUCR=0x01;
#endif	

#if defined (__AVR_ATmega103__)
	#define Networkcard_INT_Enable()	enable_external_int (1<<INT4);
	#define Networkcard_INT_Set()	EICR = 0x03;
#endif
	
#if defined (__AVR_ATmega128__)
	#define Networkcard_INT_Enable()	enable_external_int (1<<INT4);
	#define Networkcard_INT_Set()	EICR = 0x03;
#endif

#endif //_MAIN_H






